#include <stdio.h>
#include<alloc.h>
struct node
{
 int data;
 struct node *ptr;
};
typedef struct node NODE;
NODE *allocate_node();
NODE *combine(NODE *L1, NODE *L2);
NODE *ordered_insert(NODE *head, int element);
void main()
{
  int num;
  NODE *L1, *L2, *L3;
  clrscr();
  L1 = L2 = L3 = NULL;
  printf("\nEnter the element of the first list (-999 to stop)\n");
  scanf("%d",&num);
  while(num != -999)
  {
   L1 = ordered_insert(L1, num);
   scanf("%d",&num);
   fflush(stdin);
  }
  printf("\nEnter the element of the second list (-999 to stop)\n");
  scanf("%d",&num);
  while(num != -999)
  {
   L2 = ordered_insert(L2, num);
   scanf("%d",&num);
   fflush(stdin);
  }
  printf("\nThe first list in the ascending order\n");
  Ldisplay(L1);
  printf("\n");
  printf("\nThe second list in ascending order\n");
  Ldisplay(L2);
  printf("\n");
  L3 = combine(L1, L2);
  printf("\nThe combined oredred list");
  Ldisplay(L3);
  getch();
 }
NODE *ordered_insert(NODE *head, int element)
{
 NODE *new_node, *temp1, *temp2;
 new_node = allocate_node();
 new_node->data = element;
 new_node->ptr = NULL;
 if(head == NULL)
 {
  head = new_node;
  return(head);
 }
 if(element < head->data)
 {
  new_node->ptr = head;
  head = new_node;
  return(head);
 }
 temp1 = NULL;
 temp2 = head;
 while(temp2 != NULL && element > temp2->data)
 {
   temp1 = temp2;
   temp2 = temp2->ptr;
 }
 temp1->ptr = new_node;
 new_node->ptr = temp2;
 return(head);
}

NODE *combine(NODE *L1, NODE *L2)
 {
  NODE *p, *q, *r, *t;
  p = L1;
  q = L2;
  r = t= allocate_node();
  while(p != NULL && q != NULL)
  {
    if(p->data < q->data)
    {
     r->ptr = p;
     p = p->ptr;
   }
   else
   {
    r->ptr = q;
    q = q->ptr;
   }
   r = r->ptr;
  }
   if(p != NULL)
   r->ptr = p;
   else
   r->ptr = q;
   return(t->ptr);
 }
 NODE *allocate_node()
 {
  return ((NODE *)malloc(sizeof(NODE)));
 }

 Ldisplay(NODE *head)
 {
  NODE *p;
  if(head == NULL)
  printf("\nEmpty list");
  else
  {
   p = head;
   while(p != NULL)
   {
    printf("%d->",p->data);
    p = p->ptr;
   }
   printf("NULL");
   }
  return;
  }
