#include<stdio.h>
#include<alloc.h>
#include<string.h>
#include<math.h>
#include<ctype.h>
#include<dos.h>
struct node
{
 char data;
 struct node *lchild;
 struct node *rchild;
 };
 typedef struct node BTNODE;
 int stack [20],index = 0,pos=0,top=-1,length;
 char symbol, temp, infix[20],postfix[20],stack1[20];
 float eval_post(BTNODE *tree);
BTNODE *allocate_node();
BTNODE *build_tree(char suffix[]);

 void main()
 {
   BTNODE *btroot;
   float num, result;
   clrscr();
   btroot = NULL;
   printf("\nEnter the infix expression");
   scanf("%s",infix);
   infix_to_postfix();
   printf("\nThe postfix expression is %s",postfix);
   delay(100);
   btroot = build_tree(postfix);
   result = eval_post(btroot);
   printf("\nThe result after eveluation is %s = %2f\n",infix,result);
   getch();
 }
   /* building the binary tree */
BTNODE    *build_tree(char suffix[])
   {
     BTNODE  *p,*stack1[10];
     int i,j;
     char ch;
     i = j= 0;
     ch = suffix[i];
     while(ch != '\0')
     {
       p = allocate_node();
       p->data = ch;
       p->lchild = p->rchild = NULL;
       if(isalpha(ch))
       stack1[j++] = p;
       else
       {
	p->rchild = stack1[--j];
	p->lchild = stack1[--j];
	stack1[j++] = p;
       }
       i++;
       ch = suffix[i];
      }
      j--;
      return(stack1[j]);
    }
BTNODE   * allocate_node()
    {
      return ((BTNODE *)malloc(sizeof(BTNODE)));
    }
    infix_to_postfix()
    {
     length = strlen(infix);
     push('#');
     while(index < length)
     {
      symbol = infix[index];
      switch(symbol)
      {
	case '(':push(symbol);
		 break;
	case ')':temp = pop();
	while(temp != '(')
	{
	 postfix[pos++] = temp;
	 temp = pop();
       }
       break;
      case '+':
      case '-':
      case '*':
      case '/':
      case '^':while(preced(stack[top]) >= preced(symbol))
	       postfix[pos++] = pop();
	       push(symbol);
	       break;
     default:postfix[pos++] = symbol;
	     break;
       }
       index++;
     }
     while(top > 0)
     postfix[pos++] = pop();
    return;
   }
push(char symb)
 {
  stack[++top] = symb;
 return;
 }
 pop()
 {
  return (stack[top--]);
 }

 preced(char symb)
 {
   switch(symb)
   {
     case '^':return 3;
     case '*':
     case '/':return 2;
     case '+':
     case '-':return 1;
     case ')':
     case '(':return 0;
     case '#':return -1;
    default:return 7;
    }
  }
  float eval_post(BTNODE *tree)
  {
    float element,b1,b2;
    switch(tree->data)
    {
      case '+':return(eval_post(tree->lchild) + eval_post(tree->rchild));
      case '-':return(eval_post(tree->lchild) - eval_post(tree->rchild));

      case '*':return(eval_post(tree->lchild) * eval_post(tree->rchild));

      case '^':b1 = eval_post(tree->lchild);
	       b2 = eval_post(tree->rchild);
	       return(pow(b1,b2));

      case '/':return(eval_post(tree->lchild) / eval_post(tree->rchild));

      default: if(isalpha(tree->data))
	       {
		   printf("\nEnter the value of %c",tree->data);
		   scanf("%f",&element);
		   fflush(stdin);
		   return(element);
	       }
	}
	return 0;  /*This is optional. */
      }
