#include<stdio.h>
#include<string.h>
int index = 0, pos = 0, top = -1, length;
char symbol, temp;
char infix[20], postfix[20], stack[20];

void main()
{
  clrscr();
  printf("\nEnter the infix expression:\n");
  scanf("%s",infix);
  infix_to_postfix(infix,postfix);
  printf("\nInfix expression is %s\n",infix);
  printf("\nPostfix expression = %s\n",postfix);
  getch();
}
infix_to_postfix(char infix[], char postfix[])
 {
   length = strlen(infix);
   push('#');

   while(index < length)
   {
    symbol = infix[index];

    switch(symbol)
    {
      case '(':push(symbol);
	       break;
      case ')':temp = pop();
	       while(temp != '(')
		{
		 postfix[pos] = temp;
		 pos++;
		 temp = pop();
		}
		break;
      case '+':
      case '-':
      case '*':
      case '/':
      case '^':
		 while (preced(stack[top]) >= preced(symbol))
		 {
		   temp = pop();
		   postfix[pos] = temp;
		   pos++;
		 }
		 push(symbol);
		 break;
      default: postfix[pos++] = symbol;
	       break;
      }
     index++;
   }
   while(top > 0)
   {
    temp = pop();
    postfix[pos++] = temp;
   }
   return;
  }
  push(char symb)
  {
    top++;
    stack[top] = symb;
   return;
  }
  pop()
  {
    char symb;
    symb = stack[top];
    top--;
    return(symb);
  }
  int preced(char symb)
  {
    switch(symb)
     {
       case '^': return 3;
       case '*':
       case '/': return 2;
       case '+':
       case '-': return 1;
       case ')':
       case '(': return 0;
       case '#': return -1;
       default: return 7;
      }

    }