#include<alloc.h>
#include<stdio.h>
#include<stdlib.h>


struct node
{
 int data;
 struct node *ptr;
 };
 typedef struct node PQNODE;
PQNODE *pqnode(PQNODE *head, int ele);
PQNODE *pqdelete(PQNODE *head, int qnum);
PQNODE *pqinsert(PQNODE *head,int qnum);
PQNODE *allocate_node();
PQNODE *deletepq(PQNODE *head);
void pqdisplay(PQNODE *head, int qnum);

 void main()
 {
   PQNODE *pq[3];
   int choice, k ,element;

   clrscr();
   for(k=0;k<3;k++)
   pq[k] = NULL;

   while(1)
   {
     printf("\nMenu operations");
     printf("\n1. Insert");
     printf("\n2. Delete");
     printf("\n3. Display");
     printf("\n4. Exit");
     printf("\nEnter your choice");
     scanf("%d",&choice);
     switch(choice)
      {
	case 1:printf("\nEnter the queu number and element");
	       scanf("%d%d",&k,&element);

	       pq[k-1] = pqinsert(pq[k-1],element);
	       break;
	case 2:for(k=0;k<3;k++)
	       {
		 if(pq[k] == 0)
		 printf("\nQueu no %d is empty\n",k+1);
		 else
		 pq[k] = pqdelete(pq[k],k+1);
	       }
	       break;
	case 3:for(k=0;k<3;k++)
	       pqdisplay(pq[k],k+1);
	       break;
	case 4:exit(0);
	       break;
      }
   }
 }
PQNODE *pqinsert(PQNODE *head, int ele)
  {
    PQNODE  *new_node, *temp;

    new_node = allocate_node();
    new_node->data = ele;
    new_node->ptr = NULL;
    if(head == NULL)
    return(new_node);
    temp = head;
    while(temp->ptr != NULL)
    temp = temp->ptr;
    temp->ptr = new_node;
    return(head);
  }
 PQNODE *pqdelete(PQNODE *head, int qnum)
  {
   PQNODE *temp;
   printf("\nThe element of Queu %d are deleted\n",qnum);
      while(head != NULL)
      {
       printf("%d\t",head->data);

       head = deletepq(head);

      }
      return(head);
    }


PQNODE *deletepq(PQNODE *head)
{
  PQNODE *temp;
  temp = head;
  head = head->ptr;
  free(temp);
  return(head);
 }



void pqdisplay(PQNODE *head,int qnum)
  {
   PQNODE *temp;
   if(head == NULL)
   printf("\nQueu %d is empty",qnum);
   else
   {
    printf("\nElement of queu %d are\n",qnum);
    temp = head;
    while(temp != NULL)
    {
      printf("%d\t",temp->data);
      temp = temp->ptr;
    }
   }

 }
PQNODE *allocate_node()
 {
  return ((PQNODE *)malloc(sizeof(PQNODE)));
 }