#include<stdio.h>
#include<alloc.h>
#include<process.h>
#include<string.h>
struct node
{
  int info;
  struct node *llink;
  struct node *rlink;
};
typedef struct node NODE;
NODE *getnode();
NODE *insert(int item, NODE *head);
NODE *delete_item(int item, NODE *head);
NODE *minimum(NODE *root);
void inorder(NODE *root);
void preorder(NODE *root);
void postorder(NODE *root);
void main()
{
 NODE *head, *temp;
 int choice, item;
 clrscr();
 head = getnode();
 head->llink = head->rlink = NULL;
 while(1)
  {
    printf("\n1. Insert");
    printf("\n2. Display");
    printf("\n3. Delete");
    printf("\n4. Exit");
    printf("\nEnter your choice");
    scanf("%d",&choice);
    switch(choice)
     {
       case 1:printf("\nEnter the item to be inserted");
	      scanf("%d",&item);
	      head = insert(item, head);
	      break;
      case 2:if(head->llink == NULL)
	     printf("\nPriority queu is empty");
	     else
	      { printf("\nThe inorder traversal is\n");
		inorder(head->llink);

		printf("\nThe preorder traversal is\n");
		preorder(head->llink);

		printf("\nThe postorder traversal is\n");
		postorder(head->llink);

	      }
	    break;
       case 3:temp = minimum(head->llink);
	      if(temp == NULL)
	      printf("\nPriority queu is empty");
	      else
	      {
		item = temp->info;
		printf("\nThe deleted item is %d\n",item);
		head = delete_item(item, head);
	      }
	      break;
      default: exit(0);
      }
    }
  }
NODE  *getnode()
  {
    return ((NODE *)malloc(sizeof(NODE)));
  }
  void inorder(NODE *root)
  {

    if(root != NULL)
     {
       inorder(root->llink);
       printf("%d ",root->info);
       inorder(root->rlink);
     }

  }

 void  postorder(NODE *root)
   {
     if(root != NULL)
      {
       postorder(root->llink);
       postorder(root->rlink);
       printf("%d ",root->info);
     }
   }
  void  preorder(NODE *root)
   {
     if(root != NULL)
      {
       printf("%d ",root->info);
       preorder(root->llink);
       preorder(root->rlink);
     }
   }

 NODE  *insert(int item, NODE *head)
   {
     NODE *temp, *cur, *parent;
     temp = getnode();
     temp->info = item;
     temp->llink = NULL;
     temp->rlink = NULL;
     if(head->llink == NULL)
     {
       head->llink = temp;
       return head;
     }
     parent = head;
     cur = head->llink;
     while(cur != NULL)
     {
       parent = cur;
       cur = (item < cur->info) ? cur->llink:cur->rlink;
    }
    if(item < parent->info)
       parent->llink = temp;
     else
       parent->rlink = temp;
    return head;
   }

NODE   *delete_item(int item, NODE *head)
   {
     NODE *cur, *parent;
     parent = head;
     cur = head->llink;
     while(cur != NULL && item != cur->info)
     {
       parent = cur;
       cur = (item < cur->info) ? cur->llink:cur->rlink;
     }
   parent->llink = cur->rlink;
   free(cur);
   return head;
    }

NODE *minimum(NODE *root)
    {
      NODE *cur;
      if(root == NULL) return root;
      cur = root;
      while(cur->llink != NULL) cur = cur->llink;
      return cur;
    }
