#include<stdio.h>
#include<alloc.h>
#include<string.h>
struct node
{
  int data;
  struct node *lchild;
  struct node *rchild;
};
typedef struct node BTNODE;
BTNODE *INSERT(BTNODE *tree, int ele);
void main()
{
  BTNODE *btree;
  int choice, element, key, flag;
  clrscr();
  btree = NULL;
  printf("\nEnter the elements of binary tree(-999 to stop)\n");
  scanf("%d",&element);
  while(element != -999)
  {
    btree = INSERT(btree, element);
    scanf("%d",&element);
  }
  while(1)
   {
     printf("\n1. search and insert");
     printf("\n2. Display");
     printf("\n3. Exit");
     printf("\nEnter your choice");
     scanf("%d",&choice);
     switch(choice)
     {
       case 1: if(btree == NULL)
	       printf("\nEmpty treee\n");
	       else
	       {
		 flag = 0;
		 printf("\nEnter the key to be searched");
		 scanf("%d",&key);
		 SEARCH(btree,key,&flag);
		 if(flag)
		 printf("\nKey is found");
		 else
		 {
		   printf("\nKey is not found");
		   btree = INSERT(btree,key);
		 }
	       }
	       break;
      case 2:
	      printf("\nThe contents of Binary tree");
	      inorder(btree);
	      printf("\n");
	      break;
     case 3:exit(0);
    }
  }
 }

 BTNODE *INSERT(BTNODE *tree, int ele)
 {
   BTNODE *p, *q, *r;
   p = (BTNODE *)malloc(sizeof(BTNODE));
   p->data = ele;
   p->lchild = p->rchild = NULL;
   if(tree == NULL)
   return(p);
   else
    {
       q = NULL;
       r = tree;
       while(r != NULL)
       {
	 q = r;
	 if(ele == r->data)
	 {
	   printf("\nNo duplicates element");
	   printf("\nDuplicates are deleted");
	   free(p);
	   return (tree);
	 }
	 if(ele < r->data)
	 r = r->lchild;
	 else
	 r = r->rchild;
      }
      if(ele < q->data)
      q->lchild = p;
      else
      q->rchild = p;
    }
    return(tree);
  }

 SEARCH(BTNODE *tree, int element,int *found)
  {
    if(tree != NULL)
    {
      if(element == tree->data)
       {
	*found = 1;
	return (*found);
       }
       if (element < tree->data)
       SEARCH(tree->lchild, element, found);
       else
       SEARCH(tree->rchild,element,found);
    }
   return 0;
  }

  inorder(BTNODE *tree)
  {
    if(tree != NULL)
     {
       inorder(tree->lchild);
       printf(" %d ",tree->data);
       inorder(tree->rchild);
     }
    return;
   }
