#include <stdio.h>
#include <alloc.h>
#include <process.h>
struct node
{
  int v,r,c;
  struct node *rlink;
  struct node *dlink;
 };
 typedef struct node *NODE;
NODE getnode();
void initilize(NODE r[], NODE  c[], int m,int n)
 {
   int i;
   for (i=1;i<=m;i++)
   {
     r[i] = getnode();
     r[i]->c = 0;
     r[i]->dlink = NULL;
     r[i]->rlink = r[i];
   }
   for (i=1;i<=n;i++)
   {
     c[i] = getnode();
     c[i]->r = 0;
     c[i]->dlink = c[i];
     c[i]->rlink = NULL;
   }
 }
NODE  getnode()
 {
   return ((NODE)malloc(sizeof(struct node)));
 }

void insert(NODE h1, NODE h2, int v, int row, int col)
{
  NODE prev, cur, temp;
  temp = getnode();
  temp->v = v;
  temp->r = row;
  temp->c = col;

  prev = h1;
  cur = h1->rlink;

  while (cur->c < col && cur != h1)
  {
    prev = cur;
    cur = cur->rlink;
  }
  prev->rlink = temp;
  temp->rlink = cur;

  prev = h2;
  cur = h2->dlink;

  while (cur->r < row && cur != h2)
  {
    prev = cur;
    cur = cur->dlink;
  }
  prev->dlink = temp;
  temp->dlink = cur;
 }
void read_matrix (NODE r[], NODE c[])
{
  int v,row,col;
  while(1)
  {
    printf("\n To treminate enter -999\n");
    printf("\n Value=");
    scanf("%d",&v);
    if(v == -999) break;
    printf("row= "); scanf("%d", &row);
    printf("col= ");scanf("%d",&col);
    insert(r[row],c[col],v,row,col);
    }
  }
 void display(NODE r[], int m)
 {
   NODE c,h;
   int i;

   for(i=1;i<=m;i++)
   {
     h = r[i];
     c = h->rlink;
     while (c != h && c != NULL)
     {
       printf("\n (%d,%d) = %d",c->r,c->c,c->v);
       c = c->rlink;
     }
   }
 }
 void add(NODE ar[], NODE br[], NODE cr[], NODE cc[],int m)
 {
   NODE c1, c2, c;
   NODE h1, h2, h;
   int value, row, i, col;

   for (i=1;i<=m;i++)
   {
     h1 = ar[i];
     c1 = h1->rlink;
     h2 = br[i];
     c2 = h2->rlink;

     while (c1 != h1 && c2 != h2)
     {
       if(c1->c == c2->c)
       {
	 value = c1->v + c2-> v;
	 row = c1->r;
	 col = c1->c;
	 c1 = c1->rlink;
	 c2 = c2->rlink;
      }
      else if (c1->c < c2->c)
      {
	 value = c1->v;
	 row = c1->r;
	 col = c1->c;
	 c1 = c1->rlink;
       }
       else
       {
	 value = c2->v;
	 row = c2->r;
	 col = c2->c;
	 c2 = c2->rlink;
       }
       insert(cr[row],cc[col],value,row,col);
     }
     if(c1 == h)
     {
       c = c2;
       h = h2;
     }
     else
     {
       c = c1;
       h = h1;
     }
     while (c != h)
     {
       value = c->v;
       row = c->r;
       col = c->c;
       insert (cr[row],cc[col],value,row,col);
       c = c->rlink;
    }
  }
}


 void main()
 {
   int m,n;
   NODE ar[10], ac[10], br[10], bc[10], cr[10], cc[10];
   clrscr();

   printf("Enter the size of the matrix A and B \n");
   scanf("%d%d",&m,&n);

   initilize(ar,ac,m,n);
   initilize(br,bc,m,n);
   initilize(cr,cc,m,n);

   printf("\nEnter the elements of Matrix A \n");
   read_matrix(ar,ac);
   display(ar,m);
   printf("\nEnter the elements of Matrix B \n");
   read_matrix(br,bc);
   display(br,m);
   add(ar,br,cr,cc,m);
   printf("\nThe resultant matrix is c \n");
   display(cr,m);
   getch();
  }